#!/bin/sh

# 画像のbbを生成する関数．ディレクトリーを再帰的に調べる．
createBBofImageFiles() {
	local tab=""
	local i=0
	while [ $i -lt $1 ]
	do
		tab='- '${tab}
		i=`expr $i + 1`
	done

	echo ${tab}`pwd`

	for content in `ls`
	do
		if [ -d ${content} ]; then
			echo ${tab}ディレクトリー${content}を発見．
			cd ${content}
			local numTab=`expr $1 + 1`
			createBBofImageFiles ${numTab}
			cd ..
			echo ${tab}`pwd`
		else
			local ext=${content##*.}
			if [ ${ext} == "png" -o ${ext} == "jpg" -o ${ext} == "jpeg" -o \
				 ${ext} == "pdf" ]; then
				echo ${tab}${content}
				ebb ${content}
			fi
		fi
	done
}

if [ $# -eq 0 ]; then
	echo 引数が足りません．
	exit 1
fi

echo $0を実行．

TeXCore='platex' # platex, uplatex
PDFGen='dvipdfmx -V 7'

filenameWOext=${1%.*}
if [ ${#filenameWOext} -eq 0 ]; then
	echo ファイル名がありません．
	exit 1
fi
echo ${filenameWOext}'.tex -> ['${TeXCore}'] -> '${filenameWOext}'.dvi -> ['${PDFGen}'] -> '${filenameWOext}'.pdf'
echo UTF-8エンコードを想定しています．'\n'

# 環境変数の設定
source ~/.bash_profile
source ~/.bashrc
echo '$PATH='$PATH'\n'

# BBファイルの生成
if [ $2 -eq 1 ]; then
	echo 'bbファイルの生成開始．*.png *.jpg(jpeg) *.pdf'
	createBBofImageFiles 0
	echo bbファイルの生成終了．
	echo eps以外の画像の埋め込みには\\usepackage[dvipdfm]{color}が必要．'\n'
else
	echo bbファイルの生成をスキップします. '\n'
fi

# タイプセット，PDF変換
${TeXCore} $1
${PDFGen} ${filenameWOext}.dvi

# プレビューによる表示
if [ -f ${filenameWOext}.pdf ]; then
	open -a Preview ${filenameWOext}.pdf
	# osascript -e 'tell application "Preview" to activate'
fi

exit 0